/**
 * This file is part of ObjectFabric (http://objectfabric.org).
 *
 * ObjectFabric is licensed under the Apache License, Version 2.0, the terms
 * of which may be found at http://www.apache.org/licenses/LICENSE-2.0.html.
 * 
 * Copyright ObjectFabric Inc.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

package org.objectfabric;

/**
 * Return value of a method.
 */
public class ReturnValueDef extends ValueDef {

    private static final String NAME = "_return";

    public ReturnValueDef() {
        this(Platform.get().voidClass());
    }

    public ReturnValueDef(cli.System.Type type) {
        this(new TypeDef(type));
    }

    public ReturnValueDef(ClassDef classDef) {
        this(new TypeDef(classDef));
    }

    public ReturnValueDef(Immutable type) {
        this(new TypeDef(type));
    }

    public ReturnValueDef(TypeDef type) {
        super(type, NAME, null);
    }
}
